{% extends 'core/base_bs.html' %}
{% load humanize %}
{% load i18n static %}

{% block meta %}
    {{ block.super }}
    <meta name="copyright" content="New Cameroon">
    <meta name="abstract" content="{% trans "Add an ELECAM registration spot you know." %}"/>
    <meta name="description" content="{% trans "Take action to be part of new Cameroon ahead. It starts by registration on the electoral file. Find a spot near you, share and help other people find theirs." %}"/>

    <meta property="og:type" content="website"/>
    <meta property="og:site_name" content="New Cameroon">
    <meta property="og:title" content="{% trans "Find the nearest ELECAM registration spot." %}"/>
    <meta property="og:description" content="{% trans "Find the nearest ELECAM registration spot." %}"/>
    <meta property="og:url" content="{% url 'home' %}"/>
    <meta property="og:image" content="{% static 'newcameroon/img/happy-person.jpg' %}"/>
{% endblock %}

{% block page_title %}
    <title>{% trans "Add an ELECAM registration spot." %}</title>
{% endblock %}

{% block head_style %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static 'newcameroon/css/registration.css' %}?v=25.2.9">
{% endblock %}

{% block content %}
    <div class="text-center">
{#        <img src="{% static 'newcameroon/img/add-spot.jpg' %}" width="150" alt="add spot" />#}
            <img src="{% static 'newcameroon/img/cameroon-flag.jpg' %}" alt="Cameroon flag" />
    </div>
    <section>
        <div class="container">
            {% if new_spot %}
            <h2 class="page-title text-center" style="float: none; margin-bottom: 30px">{% trans "Thank you for your contribution." %}</h2>
            <div class="text-center">
                <p>
                    <span>{{ new_spot.hood }}</span>
                    <span>&nbsp;&nbsp;</span>
                    <a href="" title="{% trans "Share" %}">
                        <i class="fa fa-share-alt"></i>
                    </a>
                </p>
                <div class="text-muted">{{ new_spot.place }}</div>
                <div class="text-muted">
                {% if new_spot.category == 'Tmp' %}
                    {% trans "Temporary spot" %}: {{ new_spot.start_date }} - {{ new_spot.end_date }}
                {% else %}
                    {% trans "Branch" context "Elecam branch" %}
                {% endif %}
                </div>
                <p style="margin-top: 45px">
                    {% trans "If you like our work, please consider making a donation." %}
                </p>
                <p style="font-size: 45px">🙏&#127996;🙏&#127996;🙏&#127996;</p>
                <div class="donations">
                    <h5 style="font-size: 1.1em; font-weight: 700; margin-top: 30px">{% trans "Donate using Orange Money or MTN MoMo" %}</h5>
                    <ul style="margin: 0; padding: 0">
                        {% for suggestion in donate_suggestions %}
                        <li class="payment-start" data-amount="{{ suggestion.amount }}">
                            <div>
                                <div style="font-size: 30px">{{ suggestion.emote }}{% if forloop.counter == 1 %}&#127996;{% endif %}</div>
                                <div>
                                    <span class="text-muted currency">XAF</span>
                                    <strong class="amount">{{ suggestion.amount|intcomma }}</strong>
                                </div>
                            </div>
                        </li>
                        {% endfor %}
                    </ul>
                    <div class="clearfix"></div>
                </div>
                <p class="text-center" style="margin-top: 45px">
                    <a href="{% url 'home' %}">
                        {% trans "Return home" %}
                    </a>
                </p>
            </div>
            {% else %}
            <h1 class="page-title text-center" style="float: none">{% trans "Add an ELECAM registration spot you know." %}</h1>
            <form method="post" id="add-spot"
                  class="col-sm-10 col-md-8 col-sm-offset-1 col-md-offset-2">
                {% csrf_token %}
                <div class="form-group city">
                    <label for="city">{% trans "City" %}</label>
                    <input type="hidden" id="city-id" name="city" />
                    <input type="text" id="city" class="form-control" autofocus />
                    <div class="results cities has-shade" style="display: none; max-height: 300px; overflow: auto"
                         data-min-search-chars="3">
                        {% include 'core/snippets/spinner.html' %}
                        <ul class="object-list" style="padding-left: 0">
                            <li class="city ik-li tpl" style="display: none">
                                <div class="name"></div>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                </div>
                <div class="form-group hood">
                    <label for="hood">{% trans "Hood" %}</label>
                    <input type="hidden" id="hood-id" name="hood" />
                    <input type="text" id="hood" class="form-control" disabled />
                    <div class="results hoods has-shade" style="display: none; max-height: 300px; overflow: auto"
                         data-min-search-chars="3">
                        {% include 'core/snippets/spinner.html' %}
                        <ul class="object-list" style="padding-left: 0">
                            <li class="hood ik-li tpl" style="display: none">
                                <div class="name"></div>
                            </li>
                            <li class="ik-li tpl" id="__other__">
                                <div class="name">{% trans "Add a new hood" %}</div>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                </div>
                <div class="form-group new-hood" style="display: none">
                    <label for="new-hood">{% trans "Hood name" %}</label>
                    <input type="text" id="new-hood" name="new_hood" maxlength="100" class="form-control" />
                </div>
                <div class="form-group place">
                    <label for="place">{% trans "Place" %}</label>
                    <input type="text" id="place" name="place" class="form-control" maxlength="150">
                </div>
                <div class="form-group category">
                    <label for="category">{% trans "Type" %}</label>
                    <select id="category" class="form-control" name="category">
                        <option value="">-------</option>
                        {% for category in spot_categories %}
                            <option value="{{ category.0 }}">{{ category.1 }}</option>
                        {% endfor %}
                    </select>
                </div>
                <div class="form-group date start-date" style="display: none">
                    <label for="start-date">{% trans "Start date" %}</label>
                    <input type="date" id="start-date" name="start_date" class="form-control" />
                </div>
                <div class="form-group date end-date" style="display: none">
                    <label for="end-date">{% trans "End date" %}</label>
                    <input type="date" id="end-date" name="end_date" class="form-control" />
                </div>
                <div class="form-group">
                    <button type="submit" class="btn btn-md btn-deep-blue submit-spot">{% trans "Submit" %}</button>
                </div>
                {% if errors %}
                    <p class="error">{{ errors }}</p>
                {% endif %}
            </form>
            {% endif %}
        </div>
    </section>
    {% include 'billing/snippets/modal_payment_options.html' %}
{% endblock %}

{% block js %}
    {{ block.super }}
    <script>
        (() => {
            $('body').on('click', '.results.cities li.city', function() {
                let cityId = $(this).prop('id'),
                    cityName = $(this).find('.name').text();
                $('#city-id').val(cityId);
                $('#city').data('id', cityId).val(cityName);
                if (!cityId) {
                    $('#hood').prop('disabled', true).text("");
                    return
                }
                $('.form-group.city').removeClass('has-error');
                $('.form-group.new-hood, .form-group.date').hide();
                $('#category').val("");
                $.getJSON('/', {action: 'list_hoods', city_id: cityId}, function(data) {
                    if (data.length === 0) {
                        $('.form-group.hood').hide()
                        $('.form-group.new-hood').show()
                        $('#new-hood').focus()
                    } else {
                        $('.form-group.hood').show()
                        $('.form-group.new-hood').hide();
                        $('#hood').prop('disabled', false).val("").focus()
                    }
                })
            }).on('blur', '#city', function() {
                if ($('.city.ik-li:not(.tpl)').length > 0) $('.city.ik-li:first').click();
            }).on('click', '.results.hoods li', function() {
                let hoodId = $(this).prop('id'),
                    hoodName = $(this).find('.name').text();
                $('#hood-id').val(hoodId);
                $('#hood').val(hoodName);
                if (hoodId) $('.form-group.hood').removeClass('has-error');
                if (hoodId === '__other__') {
                    $('.form-group.new-hood').show();
                    $('#new-hood').val("").focus()
                } else {
                    $('#new-hood').val("")
                    $('.form-group.new-hood').hide();
                    $('#place').focus()
                }
            }).on('focus', '#hood', function() {
                let hoodId = $('#hood-id').val();
                if (hoodId === "__other__") {
                    $('#hood-id, #hood, #new-hood').val("")
                    $('.form-group.new-hood').hide();
                }
            }).on('blur', '#hood', function() {
                if ($('.hood.ik-li:not(.tpl)').length > 0) $('.hood.ik-li:first').click();
            }).on('keyup', '#place', function() {
                let place = $(this).val();
                if (place) $('.form-group.place').removeClass('has-error');
            }).on('change', '#category', function() {
                let category = $(this).val();
                if (category) $('.form-group.category').removeClass('has-error');
                if (category === 'Tmp') {
                    $('.form-group.date').show();
                } else {
                    $('.form-group.date').hide();
                }
            }).on('click', '.whatsapp-share', function() {
                let msg = "{% trans "If you were not yet registered, find the nearest ELECAM spot and go get registered." %}",
                    url = `{{ service.url }}`;
                window.location = 'https://api.whatsapp.com/send?text=' + url + '%0A%0A' + msg;
                {#$tpl.find('.share-spot').prop('href', `https://api.whatsapp.com/share/`)#}
            })
            $('#add-spot').submit(function() {
                let city = $('#city-id').val(),
                    hood = $('#hood-id').val(),
                    newHood = $('#new-hood').val(),
                    place = $('#place').val(),
                    category = $('#category').val(),
                    startDate = $('#start-date').val(),
                    endDate = $('#end-date').val(),
                    error = false;
                $('.form-group').removeClass('has-error');
                if (!city) {
                    $('.form-group.city').addClass('has-error');
                    error = true
                }
                if (!(hood + newHood)) {
                    $('.form-group.hood').addClass('has-error');
                    error = true
                }
                if (hood === '__other__' && !newHood) {
                    $('.form-group.new-hood').addClass('has-error');
                    error = true
                }
                if (!place) {
                    $('.form-group.place').addClass('has-error');
                    error = true
                }
                if (!category) {
                    $('.form-group.category').addClass('has-error');
                    error = true
                }
                if (category === 'Tmp' && !(startDate && endDate)) {
                    if (!startDate) $('.form-group.start-date').addClass('has-error');
                    if (!endDate) $('.form-group.end-date').addClass('has-error');
                    error = true
                }
                return !error;
            })
            $('#city').focusout(function () {
                $('.results.cities').fadeOut()
            });
            ikwen.setupSearch('#city', '.results.cities', [{
                endpoint: '/?action=list_cities',
                resultTplSelector: '.results.cities li.city',
                searchParam: 'name',
                minChars: 2,
                maxChars: function () {
                    // The max number of characters that will be taken into consideration
                    // in the string typed by user to do the search. Characters above that
                    // limit will be ignored.
                    return Math.max($('#city').val().length, 7);
                }
            }]);

            $('#hood').focusout(function () {
                $('.results.hoods').fadeOut()
            });
            ikwen.setupSearch('#hood', '.results.hoods', [{
                endpoint: function() {
                    return `/?action=list_hoods&city_id=${$('#city-id').val()}`
                },
                resultTplSelector: '.results.hoods li.hood',
                searchParam: 'name',
                minChars: 2,
                maxChars: function () {
                    // The max number of characters that will be taken into consideration
                    // in the string typed by user to do the search. Characters above that
                    // limit will be ignored.
                    return Math.max($('#hood').val().length, 7);
                }
            }]);
        })()
    </script>
{% endblock %}